var url = "http://translate.google.com/translate_t";

var xmlhttp = false;

langs = new Array();
langs[0]="en|fr : English to French";
langs[1]="fr|en : French to English";
langs[2]="en|de : English to German";
langs[3]="en|es : English to Spanish";
langs[4]="en|it : English to Italian";
langs[5]="en|pt : English to Portuguese";
langs[6]="en|ar : English to Arabic (BETA)";
langs[7]="en|jp : English to Japanese (BETA)";
langs[8]="en|ko : English to Korean (BETA)";
langs[9]="en|zh-CN : English to Chinese Simplified (BETA)";
langs[10]="de|fr : German to French";

pluginHelper.onAddCustomMenuItems = add_menu;

function view_onOpen()
{
	//no need to do anything here
}


function add_menu(menu) {
	menu.AddItem(strMenuReset,0,gadget_reset);
	//get the data again
}

function gadget_reset() {
	loading.visible = false;
	xmlhttp = false; xmlhttp = new XMLHttpRequest();
	button_translate.enabled = true;
	text_source.value = "Gadget Reset";
	text_dest.value = "";
	langpair.value = "en|fr";
}
function translate() {
	//first, check if the source text is present
	if(xmlhttp)
		if(xmlhttp.readyState != 0)
			if(xmlhttp.readyState != 4) return;
	postdata = buildpostdata();
	xmlhttp = new XMLHttpRequest();
	loading.visible = true;
	button_translate.enabled = false;
	xmlhttp.open("POST",url,true); 
	xmlhttp.send(postdata)
	xmlhttp.onreadystatechange = translate_done;
}

function buildpostdata() {
	postdata = "";
	//POSTDATA=hl=en&ie=UTF8&text=Hi+there%21&langpair=es%7Cen
	postdata += "hl=en&ie=UTF8" + "&text=" + escape(text_source.value.replace(/\s/g,"+")) + "&langpair=" + escape(langpair.value) ;
	return postdata;
}
function translate_done() {
	if(xmlhttp.readyState == 4 && xmlhttp.status == 200) {
		response = xmlhttp.responseText;
		//<div id="result_box" dir="ltr">SALUT l !</div></td>
		//Darn! They changed it! :)
		mat = response.match("<div id=result_box dir=ltr>(.*)</div></td>");
		try {
			if(mat || mat[1]) {
				mat[1] = cleanup(mat[1]);
				text_dest.value = unescape(mat[1]);
			}
		}
		catch (e) {
			loading.visible = false;
			button_translate.enabled = true;
			text_dest.value = strOptionsError;
		}
		loading.visible = false;
		button_translate.enabled = true;
	}
	else if( xmlhttp.readyState == 4 ){
		loading.visible = false;
		button_translate.enabled = true;
		text_dest.value = "";
		alert(strError1 + xmlhttp.status + "\n" + strError2 + "\n" + strError3);
	}
}

function cleanup(text) {
	//cleans up the htmlentities :)
	//simple function written by me 
	
	//First, match all the &#number; strings
	list = text.match(/&#([0-9a-fA-F]+);/g); 
	if(!list) return text;
	for(i=0; i<list.length; i++) {
		the_number = list[i].match(/\d+/g);
		text = text.replace(list[i],String.fromCharCode(the_number));
	}
	return text;
}

function help() {
	//show the users how to use this gadget.
	helptext = strHelp1 + "\n";
	for(i=0; i<langs.length; i++) {
		helptext +=  "\n" + (i+1) + ":   " + langs[i];
	}
	helptext += "\n\n" + strHelp2 + "\n\n";
	helptext += strHelp3 + "\n";
	helptext += strHelp4;
	alert(helptext);
}